% This program calculate the Fourier series approximation of a Sawtooth Function

clc;
clf;
clear all;
close all;

freq=input('Enter the frequency of the periodic signal to be generated freq=');
N=input('Enter the number of harmonics N=');
cycles=input('Enter the number of cycles to be plotted cycles=');

T=1/freq;	
w0=2*pi/T;
t_initial=-T*cycles/2;
t_final=T*cycles/2;
step=(t_final-t_initial)/1000;
t=[t_initial:step:t_final];


for n=1:N
   a(n)=0;
	b(n)=-2*cos(n*pi)/(pi*n);
end;

for ii=1:length(t)
   func(ii)=0;
   for n=1:N
      func(ii)=func(ii)+a(n)*cos(n*w0*t(ii))+b(n)*sin(n*w0*t(ii));
   end;   
end;

maxvalue=max(func);
func=func/maxvalue;

plot(t,func);

grid on;
axis ([t_initial t_final -1.5 1.5]);
Title('Sawtooth Function');

xlabel('Time t');
ylabel('Function Value');

end;